


/* -------------------------------------------------------------------------------------------------
 

   CPULOAD.C  written by Sreejith.S <sreejithsin@hotpop.com>

   shows load on the processor thru a rotating cube whose speed of rotation is proportional to load

   info accessed via /proc/stat file 

   program inspired by wmcube


--------------------------------------------------------------------------------------------------*/   




#include <math.h>           
#include <X11/Xlib.h>       
#include <stdio.h>
#include <stdlib.h>


#define   x_1  120             
#define   y_1  120 
#define   x_2  100
#define   y_2  100
#define   Radius  40  

#define PI 3.14125

void rotate_cube (void) ;    
void calc_cpu_load (void) ;
void stay_still (void ) ;

Window root , new_window ;
Display *display ;
Drawable drawable ; 
GC gc ;                     
XGCValues xgcvalues ; 

int screen ; 
float  cpu_load ;
int total_prev = 0 ;
int used_prev = 0 ;
int cpu_update = 490000 ;
int screen_speed = 10000 ;
float  delay = 1.0 ;
int delay_to_update = 0 ;
char percent [1024] ;

main ()
  
  {

  int count ;
  int x = 10 , y = 10 ;
  int border_width = 5 , width = 210 , height = 210 ;
  
    display = XOpenDisplay ( (char*)NULL ) ;
    if ( display == (Display*)NULL )
      {
        printf ( "Can't connect to the X server ! \n " ) ;
	exit (0) ;
      }

   screen = DefaultScreen ( display ) ;
   root = RootWindow ( display , screen ) ;

new_window = XCreateSimpleWindow (display,root,x,y,width,height,border_width,0,0 ) ;


		      
//XMapWindow ( display , new_window ) ;
XMapRaised (display , new_window ) ;
XStoreName (display , new_window , "cpu load " ) ;


// Setting graphics context before drawing ........

xgcvalues.foreground = WhitePixel ( display , screen ) ;
xgcvalues.background = BlackPixel ( display , screen ) ;
gc = XCreateGC ( display , new_window , (GCForeground | GCBackground ) , &xgcvalues ) ;


cpu_update  /= screen_speed ;
usleep (1009000);


while(1)

   {   
   rotate_cube () ;
   } 

 }



// routine to draw and rotate the cube ........

void rotate_cube (void) 

  {


     double angle1 ;
     double angle ;
 	
for (angle1 = 0 ; angle1 <  360 ; angle1 ++  )  {
angle = angle1 * PI / 180 ;

// Setting graphics context before drawing ........

xgcvalues.foreground = WhitePixel ( display , screen ) ;
xgcvalues.background = BlackPixel ( display , screen ) ;
gc = XCreateGC ( display , new_window , (GCForeground | GCBackground ) , &xgcvalues ) ;


    XDrawLine ( display , new_window , gc , x_1 + Radius * sin (angle) , y_1 -  Radius * cos (angle)  , x_1 + Radius * cos ( angle) , y_1 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 + Radius * sin (angle) , y_1 -  Radius * cos (angle)  , x_1 - Radius * cos ( angle) , y_1 - Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 - Radius * sin (angle) , y_1 + Radius * cos (angle)  , x_1 + Radius * cos ( angle) , y_1 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 - Radius * sin (angle) , y_1 +  Radius * cos (angle)  , x_1 - Radius * cos ( angle) , y_1 - Radius * sin (angle)) ;

    XDrawLine ( display , new_window , gc , x_2 + Radius * sin (angle) , y_2 -  Radius * cos (angle)  , x_2 + Radius * cos ( angle) , y_2 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_2 + Radius * sin (angle) , y_2 -  Radius * cos (angle)  , x_2 - Radius * cos ( angle) , y_2 - Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_2 - Radius * sin (angle) , y_2 + Radius * cos (angle)  , x_2 + Radius * cos ( angle) , y_2 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_2 - Radius * sin (angle) , y_2 +  Radius * cos (angle)  , x_2 - Radius * cos ( angle) , y_2 - Radius * sin (angle)) ;


    XDrawLine ( display , new_window , gc , x_1 - Radius * cos (angle) , y_1 -  Radius * sin (angle)  , x_2 - Radius *  cos ( angle) , y_2 - Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 + Radius * sin (angle) , y_1 -  Radius * cos (angle)  , x_2 + Radius * sin ( angle) , y_2 - Radius * cos (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 + Radius * cos (angle) , y_1 + Radius * sin (angle)  , x_2 + Radius * cos ( angle) , y_2 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 - Radius * sin (angle) , y_1 +  Radius * cos (angle)  , x_2 - Radius * sin ( angle) , y_2 + Radius * cos (angle)) ;


   
//XDrawString ( display , new_window , gc , 100 , 180 , percent , 3 ) ;

  XStoreName (display , new_window , percent ) ;
  XFlush ( display ) ;
  usleep (screen_speed) ;

// Setting graphics contest before drawing ........

xgcvalues.foreground = BlackPixel ( display , screen ) ;
xgcvalues.background = WhitePixel ( display , screen ) ;
gc = XCreateGC ( display , new_window , (GCForeground | GCBackground ) , &xgcvalues ) ;


    XDrawLine ( display , new_window , gc , x_1 + Radius * sin (angle) , y_1 -  Radius * cos (angle)  , x_1 + Radius * cos ( angle) , y_1 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 + Radius * sin (angle) , y_1 -  Radius * cos (angle)  , x_1 - Radius * cos ( angle) , y_1 - Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 - Radius * sin (angle) , y_1 + Radius * cos (angle)  , x_1 + Radius * cos ( angle) , y_1 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 - Radius * sin (angle) , y_1 +  Radius * cos (angle)  , x_1 - Radius * cos ( angle) , y_1 - Radius * sin (angle)) ;


    XDrawLine ( display , new_window , gc , x_2 + Radius * sin (angle) , y_2 -  Radius * cos (angle)  , x_2 + Radius * cos ( angle) , y_2 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_2 + Radius * sin (angle) , y_2 -  Radius * cos (angle)  , x_2 - Radius * cos ( angle) , y_2 - Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_2 - Radius * sin (angle) , y_2 + Radius * cos (angle)  , x_2 + Radius * cos ( angle) , y_2 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_2 - Radius * sin (angle) , y_2 +  Radius * cos (angle)  , x_2 - Radius * cos ( angle) , y_2 - Radius * sin (angle)) ;


    XDrawLine ( display , new_window , gc , x_1 - Radius * cos (angle) , y_1 -  Radius * sin (angle)  , x_2 - Radius *  cos ( angle) , y_2 - Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 + Radius * sin (angle) , y_1 -  Radius * cos (angle)  , x_2 + Radius * sin ( angle) , y_2 - Radius * cos (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 + Radius * cos (angle) , y_1 + Radius * sin (angle)  , x_2 + Radius * cos ( angle) , y_2 + Radius * sin (angle)) ;
    XDrawLine ( display , new_window , gc , x_1 - Radius * sin (angle) , y_1 +  Radius * cos (angle)  , x_2 - Radius * sin ( angle) , y_2 + Radius * cos (angle)) ;


if ( delay_to_update++ == (int)(cpu_update) )

 {
   delay_to_update = 0 ;
   calc_cpu_load () ;
 }


angle1 = angle1 + floor( cpu_load  / 20 );
XFlush ( display ) ;

  }  

}  
  


// routine to calculate the cpu usage .......

void calc_cpu_load (void) 

{

   FILE *fp_stat ;
   int user , nice , system , idle  ;
   int total , used ; 
   char cpu[3] ;


   fp_stat = fopen ( "/proc/stat" , "rt" ) ;
   if ( fp_stat == NULL ) { printf ( "Error opening /proc/stat file ...exiting ! \n" ) ; exit (0) ;  }



   fscanf ( fp_stat , "%s %d %d %d %d" , cpu , &user , &nice , &system , &idle ) ;
   
   total = user + nice + system + idle ;
   used = user + system + nice ;

 
 if ( (used - used_prev ) != 0 ) {

    cpu_load = (float) ( used - used_prev ) / (float) ( total - total_prev ) * 100 ;
    total_prev = total ;
    used_prev = used ;

           }

    fclose (fp_stat) ;


    strcpy ( percent , "" ) ;
    if ( cpu_load < 10 )     sprintf ( percent , "cpuload -> %01i" ,(int)cpu_load ) ;
else if ( cpu_load < 100 )
    sprintf ( percent , "cpuload -> %02i" ,(int)cpu_load ) ;
 else
    sprintf ( percent , "cpuload -> %03i" ,(int)cpu_load ) ;

  strcat ( percent, ( char * ) "%" ) ;

   }




  
